version: "3.7"

services:
    # image project
    app_api:
        container_name: app_api
        image: nextstage/php:8.2-fpm-apache-dev
        restart: unless-stopped
        volumes:
            - ./:/var/www/html
        depends_on:
            - redis
            - app_db
        env_file:
            - .env
        ports:
            - "8000:80"
        healthcheck:
            test: ["CMD", "curl", "-f", "http://localhost/api/healthcheck"]
            interval: 15s
            timeout: 5s
            retries: 10

    # image project
    app_testing:
        container_name: app_testing
        image: nextstage/php:8.2-fpm-apache-dev
        restart: unless-stopped
        volumes:
            - ./:/var/www/html
        depends_on:
            - redis
            - app_db
        env_file:
            - .env.testing

    app_db:
        container_name: app_db
        build:
            context: ./docker/postgres
            args:
                - PGVERSION=${PGVERSION}
        volumes:
            - ${PERSISTPATH}/${COMPOSE_PROJECT_NAME}/pg/${PGVERSION}/data:/var/lib/postgresql/data
        ports:
            - ${PG_EXPOSED_PORT}:5432
        environment:
            - PGVERSION=${PGVERSION}
            - POSTGRES_USER=${DB_USERNAME}
            - POSTGRES_PASSWORD=${DB_PASSWORD}
            - POSTGRES_HOST_AUTH_METHOD=md5
            - PG_MULTIPLE_DATABASES=${PG_MULTIPLE_DATABASES}
        healthcheck:
            test: ["CMD-SHELL", "pg_isready -U postgres"]
            interval: 15s
            timeout: 5s
            retries: 10

    queue:
        container_name: app_queue
        image: especializati/laravel9-app
        restart: unless-stopped
        command: "php artisan queue:work"
        volumes:
            - ./:/var/www
        depends_on:
            - redis
            - app_api

    # redis
    redis:
        container_name: app_redis
        image: redis:latest
